summaryrefslogtreecommitdiffstats
path: root/package/base-files/brcm-2.4/etc
diff options
context:
space:
mode:
Diffstat (limited to 'package/base-files/brcm-2.4/etc')
-rw-r--r--package/base-files/brcm-2.4/etc/hotplug.d/net/09-net43
-rwxr-xr-xpackage/base-files/brcm-2.4/etc/init.d/S04nvram66
-rwxr-xr-xpackage/base-files/brcm-2.4/etc/init.d/S05netconfig108
3 files changed, 217 insertions, 0 deletions
diff --git a/package/base-files/brcm-2.4/etc/hotplug.d/net/09-net b/package/base-files/brcm-2.4/etc/hotplug.d/net/09-net
new file mode 100644
index 000000000..9dd77963b
--- /dev/null
+++ b/package/base-files/brcm-2.4/etc/hotplug.d/net/09-net
@@ -0,0 +1,43 @@
+#!/bin/sh
+setup_wl()
+{
+ [ -f /proc/net/wl0 ] && {
+ lsmod | grep wlcompat >&- || insmod wlcompat
+ }
+ iwconfig "$INTERFACE" 2>&- | grep -v 'no wireless' >&- && {
+ /sbin/wifi
+ }
+}
+setup_eth()
+{
+ [ -d /proc/switch ] || {
+ insmod switch-core
+ insmod switch-robo || insmod switch-adm
+ }
+ if="$(echo "$INTERFACE" | sed s,eth,et,)"
+ ifconfig "$INTERFACE" up 2>&- >&-
+ [ -d "/proc/switch/$INTERFACE" ] || return 0
+ echo "1" > "/proc/switch/$INTERFACE/reset"
+ echo "1" > "/proc/switch/$INTERFACE/enable_vlan"
+ for vlan in $(seq 0 15); do
+ eval "hwname=\"\${vlan${vlan}hwname}\""
+ [ "$hwname" = "$if" ] && {
+ eval "vports=\"\${vlan${vlan}ports}\""
+ [ -n "$vports" ] && echo "$vports" > "/proc/switch/$INTERFACE/vlan/$vlan/ports"
+ $DEBUG vconfig add "$INTERFACE" "$vlan"
+ }
+ done
+}
+
+do_register()
+{
+ case "${INTERFACE%%[0-9]*}" in
+ eth) setup_eth;;
+ wl) setup_wl;;
+ esac
+}
+
+
+case "$ACTION" in
+ add|register) do_register;;
+esac
diff --git a/package/base-files/brcm-2.4/etc/init.d/S04nvram b/package/base-files/brcm-2.4/etc/init.d/S04nvram
new file mode 100755
index 000000000..4de124735
--- /dev/null
+++ b/package/base-files/brcm-2.4/etc/init.d/S04nvram
@@ -0,0 +1,66 @@
+#!/bin/sh
+# NVRAM setup
+#
+# This file handles the NVRAM quirks of various hardware.
+
+# WGT634u
+grep 'mtd0: 00060000' /proc/mtd 2>&- >&- && exit
+
+alias debug=${DEBUG:-:}
+
+nvram_default() {
+ [ -z "$(nvram get $1)" ] && nvram set "$1=$2"
+}
+
+nvram_set() { # for the linksys fixup part
+ [ "$(nvram get "$1")" = "$2" -a "$2" != "" ] || {
+ COMMIT=1
+ /usr/sbin/nvram set "$1=$2"
+ }
+}
+
+# work around braindead CFE defaults in linksys routers
+boardtype=$(nvram get boardtype)
+boardnum=$(nvram get boardnum)
+boardflags=$(($(nvram get boardflags)))
+adm_switch="$(( ($boardflags & 0x80) >> 7 ))"
+
+case "$(( $boardtype ))" in
+ "1800") #0x708
+ if [ "$adm_switch" = 0 ]; then
+ nvram_set sdram_init "$(printf 0x%04x $(( $(/usr/sbin/nvram get sdram_init) | 0x0100 )))"
+ [ "$COMMIT" = 1 ] && {
+ nvram_set sdram_config 0x0062
+ nvram_set clkfreq 216
+ nvram_set sdram_ncdl 0x0
+ nvram_set pa0itssit 62
+ nvram_set pa0b0 0x15eb
+ nvram_set pa0b1 0xfa82
+ nvram_set pa0b2 0xfe66
+ nvram_set pa0maxpwr 0x4e
+ }
+ fi
+ ;;
+ "1127") #0x467
+ nvram_set sdram_init "$(printf 0x%04x $(( $(/usr/sbin/nvram get sdram_init) | 0x0100 )))"
+ [ "$COMMIT" = 1 ] && {
+ nvram_set sdram_config 0x0062
+ nvram_set sdram_ncdl 0x0
+ nvram_set pa0itssit 62
+ nvram_set pa0b0 0x168b
+ nvram_set pa0b1 0xfabf
+ nvram_set pa0b2 0xfeaf
+ nvram_set pa0maxpwr 0x4e
+ }
+ ;;
+esac
+[ "$COMMIT" = "1" ] && nvram commit
+
+# hack for some motorola routers
+nvram unset wl0gpio0
+
+[ "$(nvram get il0macaddr)" = "00:90:4c:5f:00:2a" ] && {
+ # if default wifi mac, set two higher than the lan mac
+ nvram set il0macaddr=$(nvram get et0macaddr|
+ awk '{OFS=FS=":";for(x=7,y=2;--x;){$x=sprintf("%02x",(y+="0x"$x)%256);y/=256}print}')
+}
diff --git a/package/base-files/brcm-2.4/etc/init.d/S05netconfig b/package/base-files/brcm-2.4/etc/init.d/S05netconfig
new file mode 100755
index 000000000..6a626f54a
--- /dev/null
+++ b/package/base-files/brcm-2.4/etc/init.d/S05netconfig
@@ -0,0 +1,108 @@
+#!/bin/sh
+[ -e /etc/config/network ] && exit 0
+
+mkdir -p /etc/config
+
+(
+ if grep 'mtd0: 00060000' /proc/mtd 2>&- >&-; then
+ # WGT634u
+ echo boardtype=wgt634u
+ else
+ strings /dev/mtdblock/3
+ fi
+) | awk '
+function p(name) {
+ if (c[name] != "") print name "=\"" c[name] "\""
+}
+
+BEGIN {
+ FS="="
+ c["lan_ifname"]="br0"
+ c["lan_ifnames"]="vlan0 eth1"
+ c["wan_proto"]="none"
+ c["wan_ifname"]="vlan1"
+ c["vlan0ports"]="1 2 3 4 5*"
+ c["vlan1ports"]="0 5"
+}
+
+($1 == "boardnum") || ($1 == "boardtype") || ($1 == "boardflags") {
+ nvram[$1] = $2
+}
+
+END {
+ # v1 hardware
+ if (nvram["boardtype"] == "bcm94710dev") {
+ # Linksys WRT54G v1.x
+ if (nvram["boardnum"] == "42") {
+ c["vlan0ports"]=""
+ c["vlan1ports"]=""
+ c["lan_ifnames"]="vlan2 eth2"
+ }
+
+ # Asus WL-500g
+ if (nvram["boardnum"] == "asusX") {
+ c["lan_ifnames"]="eth0 eth1 eth2" # FIXME
+ # wan_ifname=eth1
+ }
+ }
+ if (nvram["boardtype"] == "wgt634u") {
+ c["vlan0ports"] = "0 1 2 3 5*"
+ c["vlan1ports"] = "4 5"
+ c["lan_ifnames"] = "vlan0 ath0"
+ }
+ if ((nvram["boardtype"] == "0x0467") || (nvram["boardtype"] == "0x042f")) {
+ c["vlan0ports"] = "0 1 2 3 5*"
+ c["vlan1ports"] = "4 5"
+ }
+
+ # WAP54G
+ if ((nvram["boardnum"] == "2") || \
+ (nvram["boardnum"] == "1024")) {
+ c["lan_ifnames"]="eth0 eth1"
+ c["wan_ifname"]=""
+ }
+
+ print "#### VLAN configuration "
+ print "vlan0hwname=et0"
+ print "vlan1hwname=et0"
+ p("vlan0ports")
+ p("vlan1ports")
+ print ""
+ print ""
+
+ print "#### LAN configuration"
+ print "lan_proto=\"static\""
+ p("lan_ifname")
+ p("lan_ifnames")
+ print "lan_ipaddr=\"192.168.1.1\""
+ print "lan_netmask=\"255.255.255.0\""
+ print "# lan_dns=\"192.168.1.1\""
+ print "# lan_gateway=\"192.168.1.1\""
+
+ print ""
+ print ""
+
+ print "#### WAN configuration"
+ print "# wan_proto: WAN protocol, available protocols:"
+ print "# none: disable"
+ print "# dhcp: DHCP"
+ print "# static: Static IP"
+ print "# pppoe: PPP over Ethernet"
+ print "# pptp: Point-to-Point tunneling Protocol"
+ print "# for pppoe and pptp you need to use wan_ifname=\"ppp0\""
+ print ""
+ print "wan_proto=dhcp"
+ p("wan_ifname")
+ print "wan_device=\"" c["wan_ifname"] "\""
+ print "# wan_ipaddr=\"192.168.0.2\""
+ print "# wan_netmask=\"255.255.255.0\""
+ print "# wan_gateway=\"192.168.0.1\""
+ print "# wan_dns=\"192.168.0.1\""
+ print ""
+ print "## PPP over Ethernet and PPTP"
+ print "# wan_ifname=\"ppp0\""
+ print "# ppp_username=\"my_username\""
+ print "# ppp_passwd=\"my_password\""
+ print "# pptp_server_ip=\"192.168.0.1\""
+}
+' > /etc/config/network